<template>
    <Table
        ref="orderTable"
        :tableParams="tableParams"
        :btnRole="[]"
        :right-btn="[]"
        isEmail
        @selectionChange="handleSelectionChange"
        isCurrentChange
        @currentChange="emailContent"
    >
    </Table>
</template>

<script setup lang="ts">
    import Table from '@/components/Table/index.vue'
    import { tableTypes } from '@/components/Table/types'
    import { listEmails,markStar,markAllRead,markRead,trashEmails,completelyDelEmails} from '@/api/emails';
    import { EmailsVO, EmailsQuery } from '@/api/emails/types';
    import { Star,StarFilled } from "@element-plus/icons-vue"
    import SvgIcon from '@/components/SvgIcon/index.vue'
    const emits = defineEmits(['refresh', 'emailContent', 'delChange', 'readChange'])
    const emailContent = (val: any) => {
        if(val) {
            emits('emailContent', val)
            if(val.isRead == 0){
                setRead(val)
            }
        }
    }
    const router: any = useRouter();
    const tableParams = reactive<tableTypes<EmailsQuery, EmailsVO>>({
        tableColumn: [
            {
                show: true,
                label: '线索名称',
                prop: 'customerName',
                width: 300,
                sortable: false,
                render: ({column}: { column: EmailsVO }) => {
                    let name = ''
                    let item = column.customerVO
                    if(item) {
                        if(item.isDelete) {
                            name = item.customerName + '（已删除）'
                        }else if(!item.isMyCustomer) {
                            name = item.customerName + '（' + (item.ownerByName ? (item.ownerByName + '的线索') : '公海线索') + '）'
                        }else{
                            name = item.customerName
                        }
                    }
                    return [
                        h('div',{style:'display:flex;align-items: center'},[
                            h(ElIcon, [
                                h(column.isStar?StarFilled:Star,{
                                    class:'star_icon',
                                    style:column.isStar?'color:#1874ff;':'',
                                    onClick: async ($event) => {
                                        $event.stopPropagation()
                                        setStar(column)
                                    }
                                })
                            ]),
                            h('div', {
                                class: !column.customerVO?.isDelete ? 'link' : '',
                                onClick: async ($event) => {
                                    $event.stopPropagation()
                                    if(!column.customerVO?.isDelete) {
                                        const { href } = router.resolve({
                                            path: '/customer/followPanel',
                                            query: {
                                                id: column.customerVO.id,
                                                resourceType: column.customerVO?.customerForm
                                            }
                                        })
                                        window.open(href, '_blank')
                                    }
                                }
                            }, name),
                        ])
                    ]
                }
            },
            { show: true, label: '线索来源', prop: 'customerVO.customerSourceName', sortable: false },
            { show: true, label: '线索状态', prop: 'customerVO.clueStatusName', sortable: false },
            { show: true, label: '所在区域', prop: 'customerVO.customerLevelName', sortable: false, render: ({ column }) => {
                return column.customerVO?.continent + '/' + column.customerVO?.country
            } },
            {
                show: true,
                label: '最后联系主题',
                prop: 'subject',
                sortable: false,
                render: ({column}: { column: EmailsVO }) => {
                    let annex = null
                    if(column.attachmentNum) {
                        annex = h(SvgIcon, { 'iconClass': 'email-annex', style: { 'margin-right': '2px', width: '16px', height: '16px' } })
                    }
                    return [
                        h('div', { style: { display: 'flex', 'align-items': 'center' } }, [
                            annex,
                            h('div', {
                                class: 'link',
                                style:column.isRead==1?'':'font-weight: bold;color:#333',
                                onClick: async ($event) => {
                                    $event.stopPropagation()
                                    const { href } = router.resolve({
                                        path: '/customer/followPanel/detail',
                                        query: {
                                            id: column.id,
                                            customerId: column.customerVO.id,
                                            resourceType: 11
                                        }
                                    })
                                    window.open(href, '_blank')
                                }
                            }, column.subject)
                        ])
                    ]
                }
            },
            { show: true, label: '最后跟进日期', prop: 'customerVO.lastFollowUpTime', sortable: false },
            // { show: true, label: '联系人', prop: 'fromName', sortable: true },
            {
                show: true, label: '操作', width: 150, prop: 'operation', disabledMove: true, render: ({ column }: { column: EmailsVO }) => {
                    return [
                        h(ElButton, {
                            link: true,
                            type: 'primary',
                            onClick:async($event)=>{
                                $event.stopPropagation()
                                const { href } = router.resolve({
                                    path: '/email/send',
                                    query: {
                                        id: column.id,
                                        type: 'reply'
                                    }
                                })
                                window.open(href, '_blank')
                            }
                        }, '回复'),
                        h(ElButton, {
                            link: true,
                            type: !column.customerVO?.isDelete && column.customerVO?.isMyCustomer ? 'primary' : 'info',
                            disabled: column.customerVO?.isDelete && !column.customerVO?.isMyCustomer,
                            onClick:async($event)=>{
                                $event.stopPropagation()
                                if(!column.customerVO?.isDelete && column.customerVO?.isMyCustomer) {
                                    const pathUrl = '/clue/add'
                                    const { href } = router.resolve({
                                        path: pathUrl,
                                        query: {
                                            type:'edit',
                                            id: column.customerVO.id
                                        }
                                    })
                                    window.open(href, '_blank')
                                }
                            }
                        }, '编辑线索')
                    ]
                }
            },
        ],
        queryParams: {
            bindCustomer: 1,
            latestMail:1,
            readStatu: null,
            blurry: '',
            customerType: 11
        },
        listFn: listEmails
    })

    const { queryParams } = toRefs(tableParams)

    const setStar = (item:any) => {
        let params = {
            isStar:item.isStar?0:1,
            emailId:item.id,
        }
        markStar(params).then(res => {
            if(res.success) {
                handleQuery()
            }
        })
    }

    const ids = ref([])
    const single:any = ref(0)
    /** 多选框选中数据 */
    const handleSelectionChange = (selection: EmailsVO[]) => {
        ids.value = selection.map(item => item.id);
        single.value = selection.length;
    }

    const setRead = (data:any) =>{
        let id = data.id
        if(single.value == 0 && data==''){
            ElMessage.error('请选择邮件')
        }else{
            let params = {
                emailIds:ids.value,
                isRead:1
            }
            if(data!=''){
                params.emailIds=id
            }
            markRead(params).then(res => {
                if(res.success) {
                    if(data!='') {
                        data.isRead = 1
                    }else{
                        handleQuery()
                    }
                }
                emits('readChange')
            })
        }
    }

    const setAllRead = () =>{
        markAllRead().then(res => {
            if(res.success) {
                handleQuery()
            }
        })
    }

    const CompletelyDel = (val:string) =>{
        if(single.value == 0){
            ElMessage.error('请选择需要删除的邮件')
        }else{
            let params = {
                emailIds:ids.value,
            }
            let tips = val==''?'':'彻底'
            ElMessageBox.confirm(
                '是否确认'+tips+'删除当前邮件？',
                '确认提示',
                { type: 'warning', confirmButtonText: '提交' }
            ).then(() => {
                if(val==''){
                    let params = {
                        emailIds:ids.value,
                        isTrash:1,
                    }
                    trashEmails(params).then(res => {
                        if(res.success) {
                            ElMessage.success('邮件已移至垃圾箱')
                            handleQuery()
                        }
                    })
                }else{
                    completelyDelEmails(ids.value).then(res => {
                        if(res.success) {
                            ElMessage.success('邮件已删除成功')
                            handleQuery()
                        }
                    })
                }

            }).catch(() => {})
        }
    }

    /** 搜索操作 */
    const orderTable = ref()
    const handleQuery = () => {
        orderTable.value.getData()
    }

    defineExpose({
        handleQuery,
        queryParams
    })
</script>

